Subject: bug#36649: 27.0.50; pure space and pdumper

From: Gerd Möllmann <[email-masked]>
Date: Sun, 3 Jul 2022 10:21:11 +0200

> On 2022-07-03,, at 9:42 , Po Lu <[email-masked]> wrote:
> 
> Gerd Möllmann <[email-masked]> writes:
> 
>> Interesting!
>> 
>> Is there something I could read about your new GC?
> 
> Not exactly.  It's a very simple 3 color incremental mark-and-sweep
> collector (which is not generational or moving) using hardware write
> barriers to keep track of changes made by the mutator.  I tried to keep
> the design of the existing garbage collector intact as much as possible.

I understand.  I think I know the 3-color algorithm.  Details don't matter that much.

> 
> Which algorithm(s) were you considering?  I think that information might
> be useful.

It's a mostly-copying GC, using VM pages and VM page protection.  The mostly-copying part was patented at the time, which I noticed too late.  AFAIU, that patent has expired, but that's a question for someone knowing US law better than me.

I can send you a C file if you want (also everyone else who wants it).  Stefan already has it.  I sent it around in 2001 or so, in the hope that it might be of some use in the future.

The C file even has some large explanatory comments, albeit I have to admit I wrote them years after the code, for sending it out.